#!/usr/bin/perl 

my ($USAGE) = 
"\n\n~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
\nUsage: perl path\...\make_cls.pl inputfile1 name alteration inputfile2 prefix \n
\nInputfile1: Sample annotation (sample info file or external information file), 
\n'name' must match one of the column headers in Inputfile1.  
\nInputfile2: .gct file. \n
\n\n~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n\n";

unless (@ARGV[0]) {print $USAGE; exit;}

use strict;
MAIN:
{
open( DATA, $ARGV[0] ) or die "ERROR: Can't open annotation file $ARGV[0]\n";  #annotation file
    my $line1 = <DATA>; 
my $name=$ARGV[1];
chomp ($name);
# my $classnum=$ARGV[2];
# chomp ($classnum);
my $type;
my $id_col;
print STDOUT "\nColumn name is: $name.\n";

my $alteration=$ARGV[2];
chomp($alteration);

my @header = split('\t', $line1);
my $ii=0;
my $id_col;
for($ii = 0; $ii <= $#header; $ii++)
	{
		my $total_col = $#header;
		if($header[$ii] =~ /^$name/)
		{
		$id_col = $ii; 
		}
	}
	my $output3;
	my $samples;
	my $rowNum = 0;
	my $samplenum;
	my $lines;
	my $gctheader;
	my @gctheader;
	my $gctcol;
	my @gctinfo;
	my $i=0;
	my $gctfilename=$ARGV[3];
		open( GCT, $ARGV[3] ) or die "ERROR: Can't open gct file $ARGV[3]\n";
		my @gctline=<GCT>;
		my $gctline;
		open(OUT,">tmp.txt") || die "Failed to open temp file to write to.\n"; 
		foreach $gctline(@gctline)
		{
		chomp $gctline;   	# Remove trailing newline character
		$rowNum++; 
	#	print STDOUT "$rowNum lines examined\n" if ( $rowNum % 10000 == 0 );
			if ($rowNum>2)
			{
			print OUT $gctline, "\n";
			}
			if($rowNum==2)
			{
			my @gctinfo = split('\t', $gctline);  #gct header lines
			$samplenum=$gctinfo[1];
			$lines=$gctinfo[0];
			}
			elsif($rowNum==3)
			{
			@gctheader = split('\t', $gctline);  #heading Data
			}
		}
		close OUT;

my $input;
	my @line = <DATA>; 			#annotation file
	my $line;
	my $missing;
	my $num=0;
	for($i= 2; $i <= $#gctheader; $i++) 					#read through gct file column headers
		{	
		foreach $line(@line)  						#for each line in annotation file
			{
			chomp $line;   						# Remove trailing newline character
			my @row = split( '\t', $line ); 			#Split on tabs in current line
			$row[$id_col]=~tr/^"//d;
			$row[$id_col]=substr($row[$id_col],0,length($name));
	
			if ($gctheader[$i] =~/^$row[0]$/) 	#does each sample in the .gct file match any line in the annotation file
				{
				if ($row[$id_col]!~/^NA/)   # pull out matching samples 
					{
					$output3=$output3." ".$row[$id_col];
					$samples=$samples."\n".$row[0];
					$num++;
					$gctcol=$gctcol."\t".$i;
					}				
				}
			}
			$input=$input."\t".$gctheader[$i];
		}
	
	my @samples=split("\n", $samples);
	for($i= 0; $i <= $#samples; $i++)
		{
		$input!~s/$samples[$i]//g;
		}
	$missing=$input;
			
$output3=~s/^\s//;
$output3=~s/\r//g;
if($alteration=~/sampleinfo/)
	{
	$output3=~s/$name/0/g;
	$output3=~tr/^WT$/1/s;
	#$output3=~tr/^NA$/2/s;
	}
my @list=split('\s',$output3);
my @sortlist=reverse sort @list;
my $classnum=$sortlist[0]+1;
print STDOUT "Number of classes is: $classnum\n";
print STDOUT "# of columns are $num, out of $#gctheader\n";
if($alteration=~/sampleinfo/)
	{
	if($classnum ==2) 
		{
	$type=" WT";
		} 
	else 
		{
	#$type=" WT  NA";
	print STDOUT "Mutation classification requires 2 classes; samples with unknown mutation status are ignored\n";
	$classnum=2;
	$type=" WT";
		}
	}
if($alteration=~/external/) 
	{
	if($classnum==2)
		{
	$type=" not_$name";
		} 
	else 
		{
	$type=" not_$name NA";
		}
	}

#need to output a reduced .gct matrix if missing samples or have NA and want only 2 classes		
	my $gctc;
	my @gctc=split("\t",$gctcol);
	my $ii=0;
	my $rown=0;
	my @gctout;
	my $gctrow;
	my $gctout;
	my $gctout1;
	my $gctout2;
	my $gctout3;
	my $count;
	my $col="1,2";
		for($ii= 1; $ii <= $#gctc; $ii++)
			{		
			my $count=$gctc[$ii]+1;
			 $col=$col.",".$count;
			}
		print STDOUT  "Columns to keep are: $col\n";

	foreach $gctline(@gctline)
		{
		chomp $gctline;   				# Remove trailing newline character
		my @gctrow = split('\t',$gctline);   		#each row split by tabs
		$rown++;
	#	print STDOUT "$rown lines examined\n" if ( $rown % 10000 == 0 );
		if ($rown==1 )
			{
			$gctout1= $gctline."\n";   		#want to keep 1st 2 lines
			}
		elsif ($rown==2)
			{	
			$gctout2=$lines."\t".$num."\n";
			}
		}

	print "\nLines that matched are: $samples\n";
	my @nonmatch=split('\t',$missing);
	my $seen;
	
	my %seen=();
	my @uniq=();
	@uniq= grep { ! $seen{$_} ++ } @nonmatch;

	my $missing2=join("\n",@uniq);
	print STDOUT "Non-matching samples (or samples with 'NA' as status) are: $missing2\n";
	close(DATA);
	
my $output1="$num $classnum 1\n";
my $output2="# $name$type\n";
my @filename;
#print "Output .cls filename?\n";	
my $prefix=$ARGV[4];
chomp ($prefix);
my $filename=$prefix.".cls";
open(OUT, ">$filename") || die "Failed to open $filename to write to.\n"; 
print OUT $output1.$output2.$output3;
close(OUT);

open(OUT,">tmpheader.txt") || die "Failed to open temp file to write to.\n"; 
print OUT $gctout1.$gctout2;
close OUT;
#system("more +3 $ARGV[3] >tmp.txt");
system("cut -f $col tmp.txt > tmp2.txt");

my @filename2;	
my $filename2=$prefix.".gct";
open(OUT, ">$filename2") || die "Failed to open $filename2 to write to.\n"; 
system("cat tmpheader.txt tmp2.txt > $filename2");

close(OUT);
close(GCT);	
system("rm tmp.txt");
system("rm tmp2.txt");
system("rm tmpheader.txt");
}